// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.ApiApps;
using Microsoft.Azure.Management.ApiApps.Models;

namespace Microsoft.Azure.Management.ApiApps
{
    /// <summary>
    /// The Microsoft Azure ApiApp management API provides a RESTful set of web
    /// services that interact with Microsoft Azure ApiApp service to manage
    /// your ApiApps. The API has entities that capture the relationship
    /// between an end user and the Microsoft Azure ApiApp service.  (see
    /// http://azure.microsoft.com/en-us/services/app-service/api/ for more
    /// information)
    /// </summary>
    public static partial class TemplateOperationsExtensions
    {
        /// <summary>
        /// Get metadata for deploying a package to the given resource group
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.ApiApps.ITemplateOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters for operation
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static GetDeploymentTemplateMetadataResponse GetMetadata(this ITemplateOperations operations, GetDeploymentMetadataRequest parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((ITemplateOperations)s).GetMetadataAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Get metadata for deploying a package to the given resource group
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.ApiApps.ITemplateOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters for operation
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<GetDeploymentTemplateMetadataResponse> GetMetadataAsync(this ITemplateOperations operations, GetDeploymentMetadataRequest parameters)
        {
            return operations.GetMetadataAsync(parameters, CancellationToken.None);
        }
    }
}
