// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of the configuration parameter type.
    /// </summary>
    public partial class DscConfigurationParameter
    {
        private string _defaultValue;
        
        /// <summary>
        /// Optional. Gets or sets the default value of parameter.
        /// </summary>
        public string DefaultValue
        {
            get { return this._defaultValue; }
            set { this._defaultValue = value; }
        }
        
        private bool _isMandatory;
        
        /// <summary>
        /// Optional. Gets or sets a Boolean value to indicate whether the
        /// parameter is madatory or not.
        /// </summary>
        public bool IsMandatory
        {
            get { return this._isMandatory; }
            set { this._isMandatory = value; }
        }
        
        private int _position;
        
        /// <summary>
        /// Optional. Get or sets the position of the parameter.
        /// </summary>
        public int Position
        {
            get { return this._position; }
            set { this._position = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Optional. Gets or sets the type of the parameter.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DscConfigurationParameter class.
        /// </summary>
        public DscConfigurationParameter()
        {
        }
    }
}
