// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A Data Lake Analytics catalog U-SQL credential item.
    /// </summary>
    public partial class USqlCredential
    {
        /// <summary>
        /// Initializes a new instance of the USqlCredential class.
        /// </summary>
        public USqlCredential() { }

        /// <summary>
        /// Initializes a new instance of the USqlCredential class.
        /// </summary>
        public USqlCredential(string databaseName = default(string), string identity = default(string), string credentialName = default(string), string userName = default(string), string computeAccountName = default(string), string version = default(string))
        {
            DatabaseName = databaseName;
            Identity = identity;
            CredentialName = credentialName;
            UserName = userName;
            ComputeAccountName = computeAccountName;
            Version = version;
        }

        /// <summary>
        /// Gets or sets the name of the database the credential is in.
        /// </summary>
        [JsonProperty(PropertyName = "databaseName")]
        public string DatabaseName { get; set; }

        /// <summary>
        /// Gets or sets the name of the secret associated with the credential.
        /// </summary>
        [JsonProperty(PropertyName = "identity")]
        public string Identity { get; set; }

        /// <summary>
        /// Gets or sets the name of the credential.
        /// </summary>
        [JsonProperty(PropertyName = "credentialName")]
        public string CredentialName { get; set; }

        /// <summary>
        /// Gets or sets the user name associated with the credential.
        /// </summary>
        [JsonProperty(PropertyName = "userName")]
        public string UserName { get; set; }

        /// <summary>
        /// Gets or sets the name of the Data Lake Analytics account.
        /// </summary>
        [JsonProperty(PropertyName = "computeAccountName")]
        public string ComputeAccountName { get; set; }

        /// <summary>
        /// Gets or sets the version of the catalog item.
        /// </summary>
        [JsonProperty(PropertyName = "version")]
        public string Version { get; set; }

    }
}
