// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.KeyVault;

namespace Microsoft.Azure.Management.KeyVault
{
    /// <summary>
    /// Properties of the vault
    /// </summary>
    public partial class VaultProperties
    {
        private IList<AccessPolicyEntry> _accessPolicies;
        
        /// <summary>
        /// Optional. Access policies for one or more principals
        /// </summary>
        public IList<AccessPolicyEntry> AccessPolicies
        {
            get { return this._accessPolicies; }
            set { this._accessPolicies = value; }
        }
        
        private bool _enabledForDeployment;
        
        /// <summary>
        /// Optional. Enabled or disabled for deployment
        /// </summary>
        public bool EnabledForDeployment
        {
            get { return this._enabledForDeployment; }
            set { this._enabledForDeployment = value; }
        }
        
        private Sku _sku;
        
        /// <summary>
        /// Optional. SKU details
        /// </summary>
        public Sku Sku
        {
            get { return this._sku; }
            set { this._sku = value; }
        }
        
        private Guid _tenantId;
        
        /// <summary>
        /// Optional. Tenant ID
        /// </summary>
        public Guid TenantId
        {
            get { return this._tenantId; }
            set { this._tenantId = value; }
        }
        
        private string _vaultUri;
        
        /// <summary>
        /// Optional. URL of the vault
        /// </summary>
        public string VaultUri
        {
            get { return this._vaultUri; }
            set { this._vaultUri = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VaultProperties class.
        /// </summary>
        public VaultProperties()
        {
            this.AccessPolicies = new LazyList<AccessPolicyEntry>();
        }
    }
}
