// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;

namespace Microsoft.WindowsAzure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The response model for the upload certificate response
    /// </summary>
    public partial class UploadCertificateResponse : AzureOperationResponse
    {
        private string _contractVersion;
        
        /// <summary>
        /// Required. Contract version for the entity.
        /// </summary>
        public string ContractVersion
        {
            get { return this._contractVersion; }
            set { this._contractVersion = value; }
        }
        
        private string _globalAcsHostName;
        
        /// <summary>
        /// Required. Global ACS Host name.
        /// </summary>
        public string GlobalAcsHostName
        {
            get { return this._globalAcsHostName; }
            set { this._globalAcsHostName = value; }
        }
        
        private string _globalAcsNamespace;
        
        /// <summary>
        /// Required. Global ACS Namespace.
        /// </summary>
        public string GlobalAcsNamespace
        {
            get { return this._globalAcsNamespace; }
            set { this._globalAcsNamespace = value; }
        }
        
        private string _globalAcsRPRealm;
        
        /// <summary>
        /// Required. Global ACS RP realm.
        /// </summary>
        public string GlobalAcsRPRealm
        {
            get { return this._globalAcsRPRealm; }
            set { this._globalAcsRPRealm = value; }
        }
        
        private long _resourceId;
        
        /// <summary>
        /// Required. ASR vault id: resource id
        /// </summary>
        public long ResourceId
        {
            get { return this._resourceId; }
            set { this._resourceId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the UploadCertificateResponse class.
        /// </summary>
        public UploadCertificateResponse()
        {
        }
    }
}
