// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.TrafficManager.Models
{
    public enum EndpointType
    {
        /// <summary>
        /// The type of Azure Cloud Services from the current subscription.
        /// </summary>
        CloudService = 0,
        
        /// <summary>
        /// The type of Azure Websites from the current subscription.
        /// </summary>
        AzureWebsite = 1,
        
        /// <summary>
        /// The type of endpoints that can have any domain name (not
        /// necessarily an Azure domain). Note that Azure Websites cannot be
        /// entered as endpoints of type "Any".
        /// </summary>
        Any = 2,
        
        /// <summary>
        /// The type of endpoint that points to a Traffic Manager profile from
        /// the current subscription.
        /// </summary>
        TrafficManager = 3,
    }
}
